// ==UserScript==
// @name         CloudCone VPS Auto Purchase (Stock Status)
// @namespace    http://tampermonkey.net/
// @version      1.3
// @description  Auto-purchase script for CloudCone VPS with stock status messages
// @author       Your Name
// @match        https://app.cloudcone.com/vps/333/create?token=bf-24-hfs-jbwzIuIoOGB9
// @grant        none
// ==/UserScript==

(function () {
    'use strict';

    // 在页面的 <div class="container"> 内创建日志区域
    function createLogArea() {
        const container = document.querySelector('.container');
        if (!container) {
            console.error("未找到 .container 元素，无法添加日志区域！");
            return;
        }

        const logArea = document.createElement('div');
        logArea.id = 'log-area';
        logArea.style.backgroundColor = '#f9f9f9';
        logArea.style.border = '1px solid #ccc';
        logArea.style.padding = '10px';
        logArea.style.marginTop = '20px';
        logArea.style.maxHeight = '200px';
        logArea.style.overflowY = 'auto';
        logArea.style.fontSize = '14px';
        logArea.style.color = '#333';
        logArea.innerHTML = '<strong>执行日志：</strong><br>';
        container.appendChild(logArea);
    }

    // 添加日志到日志区域
    function addLog(message) {
        const logArea = document.getElementById('log-area');
        if (logArea) {
            const logMessage = document.createElement('div');
            logMessage.textContent = `[${new Date().toLocaleTimeString()}] ${message}`;
            logArea.appendChild(logMessage);
            logArea.scrollTop = logArea.scrollHeight; // 滚动到底部
        }
    }

    // 创建日志区域
    createLogArea();

    // 检查库存并执行操作
    function checkAndPurchase() {
        const buttonGroup = document.querySelector('.btn-group.bootstrap-select');
        if (!buttonGroup) {
            addLog("未找到按钮组，无法检测库存！");
            return;
        }

        const spanTag = buttonGroup.querySelector('span.filter-option.pull-left');
        if (spanTag) {
            const spanText = spanTag.textContent.trim(); // 获取 <span> 的文本内容

            // 检测库存状态
            if (spanText.includes("(Out of Stock)")) {
                addLog(`检测到库存状态：${spanText}，当前无货`);
                addLog("页面即将刷新...");
                setTimeout(() => {
                    location.reload(); // 刷新页面
                }, 5000);
            } else {
                addLog(`检测到库存状态：${spanText}，当前有货`);
                addLog("库存满足条件，正在执行下单操作...");

                // 填写 Hostname
                const hostnameInput = document.querySelector('input[name="hostname"]');
                if (hostnameInput) {
                    hostnameInput.value = "cloudcone.vps";
                    addLog("已填写 Hostname 为 cloudcone.vps");
                }

                // 点击提交按钮
                const deployButton = document.querySelector('.btn-fill.btn-block.btn-magnify.btn-danger.btn-lg.deploy-server-btn');
                if (deployButton) {
                    deployButton.click();
                    addLog("下单操作已执行！");
                } else {
                    addLog("未找到提交按钮，下单失败！");
                }
            }
        } else {
            addLog("未找到目标 <span> 标签，无法检测库存！");
        }
    }

    // 每隔5秒检查一次库存
    setInterval(checkAndPurchase, 5000);
})();
